/*
 * Bool.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "Bool.h"
#include <object/Object.h>

#include <registration/StringRegistration.hpp>

namespace core {

bool stringApi < bool >::parse ( std::istream & ) {
	throw exception::CommonException("parsing bool from string not implemented");
}

bool stringApi < bool >::first ( std::istream & ) {
	return false;
}

void stringApi < bool >::compose ( std::ostream & output, bool primitive ) {
	output << ( primitive ? "true" : "false" );
}

primitive::Bool stringApi < primitive::Bool >::parse ( std::istream & input ) {
	return primitive::Bool ( stringApi < bool >::parse ( input ) );
}

bool stringApi < primitive::Bool >::first ( std::istream & input ) {
	return stringApi < bool >::first ( input );
}

void stringApi < primitive::Bool >::compose ( std::ostream & output, const primitive::Bool & primitive ) {
	stringApi < bool >::compose ( output, primitive.getData ( ) );
}

} /* namespace core */

namespace {

static auto stringWrite = registration::StringWriterRegister < primitive::Bool > ( );

static auto stringWriteGroup = registration::StringWriterRegisterTypeInGroup < object::Object, primitive::Bool > ( );

} /* namespace */
