/*
 * Unsigned.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "Unsigned.h"
#include <object/Object.h>

#include <registration/StringRegistration.hpp>

namespace core {

unsigned stringApi < unsigned >::parse ( std::istream & ) {
	throw exception::CommonException("parsing unsigned from string not implemented");
}

bool stringApi < unsigned >::first ( std::istream & ) {
	return false;
}

void stringApi < unsigned >::compose ( std::ostream & output, unsigned primitive ) {
	output << primitive;
}

primitive::Unsigned stringApi < primitive::Unsigned >::parse ( std::istream & input ) {
	return primitive::Unsigned ( stringApi < unsigned >::parse ( input ) );
}

bool stringApi < primitive::Unsigned >::first ( std::istream & input ) {
	return stringApi < unsigned >::first ( input );
}

void stringApi < primitive::Unsigned >::compose ( std::ostream & output, const primitive::Unsigned & primitive ) {
	stringApi < unsigned >::compose ( output, primitive.getData ( ) );
}

} /* namespace core */

namespace {

static auto stringWrite = registration::StringWriterRegister < primitive::Unsigned > ( );

static auto stringWriteGroup = registration::StringWriterRegisterTypeInGroup < object::Object, primitive::Unsigned > ( );

} /* namespace */
