#include "ObjectTest.h"

#include <object/Object.h>
#include <factory/StringDataFactory.hpp>

#include <sstream>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( ObjectTest, "label" );
CPPUNIT_TEST_SUITE_REGISTRATION( ObjectTest );

void ObjectTest::setUp() {
}

void ObjectTest::tearDown() {
}

void ObjectTest::testComposing() {
	std::string input = "(1, 2)";
	object::Object label = factory::StringDataFactory::fromString (input);

	std::string output = factory::StringDataFactory::toString(label);
	CPPUNIT_ASSERT( input == output );

	std::stringstream out;
	factory::StringDataFactory::toStream ( label, out );
	std::string output2 = out.str();
	CPPUNIT_ASSERT( input == output2 );

	std::stringstream out2;
	factory::StringDataFactory::toStream ( label, out2 );
	std::string output3 = out2.str();
	CPPUNIT_ASSERT( input == output3 );
}

